// split a multi-byte positive natural number into a byte string it consists of
// if the number is too big for numBytes, num modulo 256^numBytes will be returned
function numToByteStr(num, numBytes) {
  var bytes = "";
  numBytes = numBytes || Math.ceil(Math.log(Math.abs(num)) / Math.log(0xFF));
  for(var i = 0; i < numBytes; i++) {
    bytes += String.fromCharCode(0xFF & (num >>> (8 * i)));
  }
  return bytes;
}


/* based on code in rfc 1952, translated into javascript and adapted for usage here
   Copyright (c) 1996 L. Peter Deutsch

   Permission is granted to copy and distribute this document for any
   purpose and without charge, including translations into other
   languages and incorporation into compilations, provided that the
   copyright notice and this notice are preserved, and that any
   substantive changes or deletions from the original are clearly
   marked.
*/
var crc32 = (function() {
  var crc_table = [];
  function makeCrcTable() {
    for(var n = 0; n <= 0xFF; n++) {
      var c = n;
      for(var k = 0; k < 8; k++) {
        if(c & 1)
          c = 0xedb88320 ^ (c >>> 1);
        else
          c = c >>> 1;
      }
      crc_table[n] = c;
    }
  }
  return function crc32(buf, crc) {
    if(!crc_table.length) makeCrcTable();
    crc = crc ? (crc ^ 0xffffffff) : 0xffffffff;
    for(var n = 0; n < buf.length; n++) {
      crc = crc_table[(crc ^ buf.charCodeAt(n)) & 0xff] ^ (crc >>> 8);
    }
    return crc ^ 0xffffffff;
  };
})();